"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.storeMetric = storeMetric;
exports.deleteMetric = deleteMetric;
exports.addToQueue = addToQueue;
exports.clearQueue = clearQueue;
exports.updateMetricsStatus = updateMetricsStatus;
exports.UPDATE_METRICS_STATUS = exports.STORE_END = exports.STORE_START = exports.CLEAR_QUEUE = exports.ADD_TO_QUEUE = exports.DELETE_METRIC = exports.STORE_METRIC = void 0;
var STORE_METRIC = 'metrics/STORE_METRIC';
exports.STORE_METRIC = STORE_METRIC;
var DELETE_METRIC = 'metrics/DELETE_METRIC';
exports.DELETE_METRIC = DELETE_METRIC;
var ADD_TO_QUEUE = 'metrics/ADD_TO_QUEUE';
exports.ADD_TO_QUEUE = ADD_TO_QUEUE;
var CLEAR_QUEUE = 'metrics/CLEAR_QUEUE';
exports.CLEAR_QUEUE = CLEAR_QUEUE;
var STORE_START = 'metrics/STORE_START';
exports.STORE_START = STORE_START;
var STORE_END = 'metrics/STORE_END';
exports.STORE_END = STORE_END;
var UPDATE_METRICS_STATUS = 'metrics/UPDATE_METRICS_STATUS';
exports.UPDATE_METRICS_STATUS = UPDATE_METRICS_STATUS;

function storeMetric(name, data) {
  return {
    type: STORE_METRIC,
    payload: {
      name: name,
      data: data
    }
  };
}

function deleteMetric(name) {
  return {
    type: DELETE_METRIC,
    payload: {
      name: name
    }
  };
}

function addToQueue(data) {
  return {
    type: ADD_TO_QUEUE,
    payload: {
      data: data
    }
  };
}

function clearQueue() {
  return {
    type: CLEAR_QUEUE
  };
}

function updateMetricsStatus(status) {
  return {
    type: UPDATE_METRICS_STATUS,
    payload: {
      status: status
    }
  };
}