"use strict";

var _Object$defineProperty = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = reducer;

var _immutable = require("immutable");

var _actions = require("./actions");

var initialState = (0, _immutable.fromJS)({
  items: {},
  queue: [],
  status: {
    isSendingQueue: false
  }
});

function reducer() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initialState;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case _actions.STORE_METRIC:
      return state.setIn(['items', action.payload.name], (0, _immutable.fromJS)(action.payload.data));

    case _actions.DELETE_METRIC:
      return state.deleteIn(['items', action.payload.name]);

    case _actions.ADD_TO_QUEUE:
      {
        var newQueue = state.get('queue').push((0, _immutable.fromJS)(action.payload.data));
        return state.set('queue', newQueue);
      }

    case _actions.CLEAR_QUEUE:
      return state.set('queue', (0, _immutable.fromJS)([]));

    case _actions.UPDATE_METRICS_STATUS:
      return state.mergeDeepIn(['status'], action.payload.status);

    default:
      return state;
  }
}