"use strict";

var _interopRequireWildcard = require("@babel/runtime-corejs2/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

var _Object$defineProperty2 = require("@babel/runtime-corejs2/core-js/object/define-property");

_Object$defineProperty2(exports, "__esModule", {
  value: true
});

exports.default = withSparkMetrics;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-property"));

var _defineProperties = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/define-properties"));

var _getOwnPropertyDescriptors = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptors"));

var _getOwnPropertySymbols = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-symbols"));

var _keys = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/keys"));

var _getOwnPropertyDescriptor = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/get-own-property-descriptor"));

var _extends2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/extends"));

var _promise = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/promise"));

var _defineProperty3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _assign = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/object/assign"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _applyDecoratedDescriptor2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/applyDecoratedDescriptor"));

var _react = _interopRequireWildcard(require("react"));

var _reactTransformHmr3 = _interopRequireDefault(require("react-transform-hmr"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _redux = require("redux");

var _reactRedux = require("react-redux");

var _coreDecorators = require("core-decorators");

var _recompose = require("recompose");

var _actions = require("./actions");

var _metricsEvents = _interopRequireDefault(require("./metrics-events"));

function ownKeys(object, enumerableOnly) { var keys = (0, _keys.default)(object); if (_getOwnPropertySymbols.default) { var symbols = (0, _getOwnPropertySymbols.default)(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return (0, _getOwnPropertyDescriptor.default)(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty3.default)(target, key, source[key]); }); } else if (_getOwnPropertyDescriptors.default) { (0, _defineProperties.default)(target, (0, _getOwnPropertyDescriptors.default)(source)); } else { ownKeys(Object(source)).forEach(function (key) { (0, _defineProperty2.default)(target, key, (0, _getOwnPropertyDescriptor.default)(source, key)); }); } } return target; }

var _components = {
  InjectSparkMetrics: {
    displayName: "InjectSparkMetrics",
    isInFunction: true
  }
};

var _reactTransformHmr2 = (0, _reactTransformHmr3.default)({
  filename: "packages/node_modules/@ciscospark/react-redux-spark-metrics/src/withSparkMetrics.js",
  components: _components,
  locals: [module],
  imports: [_react.default]
});

function _wrapComponent(id) {
  return function (Component) {
    return _reactTransformHmr2(Component, id);
  };
}

var NS = 'ciscospark-widget-';

function withSparkMetrics(widgetName) {
  var defaultFields = {
    protocol: window.location.protocol,
    hostname: window.location.hostname,
    pathname: window.location.pathname,
    widgetVersion: process.env.REACT_WEBEX_VERSION,
    iteration: 0
  };
  var defaultTags = {
    widgetName: widgetName
  };
  return function (BaseComponent) {
    var _class;

    /* eslint-disable-reason need to refactor before adding default props */

    /* eslint-disable react/require-default-props */
    var injectedProps = {
      sparkInstance: _propTypes.default.object,
      sparkState: _propTypes.default.object,
      metricsStore: _propTypes.default.object,
      updateMetricsStatus: _propTypes.default.func,
      deleteMetric: _propTypes.default.func,
      storeMetric: _propTypes.default.func,
      addToQueue: _propTypes.default.func,
      clearQueue: _propTypes.default.func
    };
    var InjectSparkMetrics = (_class =
    /*#__PURE__*/
    function (_Component) {
      (0, _inherits2.default)(InjectSparkMetrics, _Component);
      (0, _createClass2.default)(InjectSparkMetrics, null, [{
        key: "formatMetricData",
        value: function formatMetricData(_ref) {
          var data = _ref.data,
              action = _ref.action,
              event = _ref.event,
              fields = _ref.fields,
              tags = _ref.tags;
          return {
            type: ['operational'],
            tags: (0, _assign.default)({}, defaultTags, {
              action: action,
              event: event
            }, tags),
            fields: (0, _assign.default)({}, defaultFields, {
              data: data
            }, fields)
          };
        }
      }]);

      function InjectSparkMetrics(props) {
        var _this;

        (0, _classCallCheck2.default)(this, InjectSparkMetrics);
        _this = (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(InjectSparkMetrics).call(this, props));
        _this.startTime = window.performance.now();
        return _this;
      }

      (0, _createClass2.default)(InjectSparkMetrics, [{
        key: "componentWillMount",
        value: function componentWillMount() {
          this.sendStartMetric(_objectSpread({}, _metricsEvents.default.WIDGET_LOAD, {
            data: this.startTime
          }));
        }
      }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
          // Try to send queue on every load if there is something to send
          this.sendQueue(nextProps);
        }
      }, {
        key: "shouldComponentUpdate",
        value: function shouldComponentUpdate() {
          return true;
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this.sendElapsedTime(_metricsEvents.default.WIDGET_UNMOUNT);
        }
      }, {
        key: "canSendMetric",
        value: function canSendMetric() {
          var _this$props = this.props,
              sparkInstance = _this$props.sparkInstance,
              sparkState = _this$props.sparkState;
          return sparkInstance && sparkState.get('authenticated') && sparkState.get('registered');
        }
      }, {
        key: "hasQueuedMetrics",
        value: function hasQueuedMetrics() {
          var metricsStore = this.props.metricsStore;
          return metricsStore && metricsStore.get('queue').count();
        }
      }, {
        key: "sendMetric",
        value: function sendMetric(metric) {
          var props = this.props;
          var sparkInstance = props.sparkInstance;
          var resource = metric.resource;
          var formattedData = InjectSparkMetrics.formatMetricData(metric);

          if (this.canSendMetric()) {
            try {
              return sparkInstance.internal.metrics.submitClientMetrics("".concat(NS).concat(resource), formattedData);
            } catch (e) {// Don't do anything
            }
          }

          return props.addToQueue(metric);
        }
      }, {
        key: "sendElapsedTime",
        value: function sendElapsedTime(metric) {
          if (metric) {
            var updatedMetric = (0, _assign.default)({}, metric);
            updatedMetric.data = window.performance.now() - this.startTime;
            return this.sendMetric(updatedMetric);
          }

          return _promise.default.resolve();
        }
      }, {
        key: "sendSavedMetric",
        value: function sendSavedMetric(metricName) {
          var props = this.props;
          var metricsStore = props.metricsStore;
          var metric = metricsStore.getIn(['items', metricName]);

          if (metric) {
            return this.sendMetric(metric.toJS()).then(function () {
              return props.deleteMetric(metricName);
            });
          }

          return false;
        }
      }, {
        key: "sendQueue",
        value: function sendQueue(props) {
          var canSendMetric = this.canSendMetric,
              hasQueuedMetrics = this.hasQueuedMetrics,
              sendMetric = this.sendMetric;
          var metricsStore = props.metricsStore;

          if (canSendMetric() && hasQueuedMetrics() && !metricsStore.getIn(['status', 'isSendingQueue'])) {
            props.updateMetricsStatus({
              isSendingQueue: true
            });
            return _promise.default.all(metricsStore.get('queue').map(function (metric) {
              return sendMetric(metric.toJS());
            })).then(function () {
              props.clearQueue();
              return props.updateMetricsStatus({
                isSendingQueue: false
              });
            });
          }

          return _promise.default.resolve();
        }
      }, {
        key: "sendStartMetric",
        value: function sendStartMetric(metric) {
          var computedMetric = (0, _assign.default)({}, {
            action: 'start',
            data: window.performance.now()
          }, metric);
          var metricName = [metric.resource, metric.event, 'start'].join(':');
          this.props.storeMetric(metricName, computedMetric);
          return this.sendMetric(computedMetric);
        }
      }, {
        key: "sendEndMetric",
        value: function sendEndMetric(metric) {
          // Grab end timestamp
          var end = window.performance.now(); // Check for starting time

          var startName = [metric.resource, metric.event, 'start'].join(':');
          var start = this.props.metricsStore.getIn(['items', startName, 'data']);

          if (start) {
            // construct and send end metric
            var endMetric = (0, _assign.default)({}, {
              action: 'end',
              data: end
            }, metric);
            var sendEnd = this.sendMetric(endMetric); // construct and send duration metric

            var durationMetric = (0, _assign.default)({}, {
              action: 'duration',
              data: end - start
            }, metric);
            var sendDuration = this.sendMetric(durationMetric);
            this.props.deleteMetric(startName);
            return _promise.default.all([sendEnd, sendDuration]);
          }

          return _promise.default.resolve();
        }
      }, {
        key: "render",
        value: function render() {
          var sendQueue = this.sendQueue,
              sendMetric = this.sendMetric,
              sendElapsedTime = this.sendElapsedTime,
              sendStartMetric = this.sendStartMetric,
              sendEndMetric = this.sendEndMetric;
          var metrics = {
            sendQueue: sendQueue,
            sendMetric: sendMetric,
            sendElapsedTime: sendElapsedTime,
            sendStartMetric: sendStartMetric,
            sendEndMetric: sendEndMetric
          };
          return _react.default.createElement(BaseComponent, (0, _extends2.default)({}, this.props, {
            metrics: metrics
          }));
        }
      }]);
      return InjectSparkMetrics;
    }(_react.Component), ((0, _applyDecoratedDescriptor2.default)(_class.prototype, "canSendMetric", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "canSendMetric"), _class.prototype), (0, _applyDecoratedDescriptor2.default)(_class.prototype, "hasQueuedMetrics", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "hasQueuedMetrics"), _class.prototype), (0, _applyDecoratedDescriptor2.default)(_class.prototype, "sendMetric", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "sendMetric"), _class.prototype), (0, _applyDecoratedDescriptor2.default)(_class.prototype, "sendElapsedTime", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "sendElapsedTime"), _class.prototype), (0, _applyDecoratedDescriptor2.default)(_class.prototype, "sendSavedMetric", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "sendSavedMetric"), _class.prototype), (0, _applyDecoratedDescriptor2.default)(_class.prototype, "sendQueue", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "sendQueue"), _class.prototype), (0, _applyDecoratedDescriptor2.default)(_class.prototype, "sendStartMetric", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "sendStartMetric"), _class.prototype), (0, _applyDecoratedDescriptor2.default)(_class.prototype, "sendEndMetric", [_coreDecorators.autobind], (0, _getOwnPropertyDescriptor.default)(_class.prototype, "sendEndMetric"), _class.prototype)), _class);
    InjectSparkMetrics = _wrapComponent("InjectSparkMetrics")(InjectSparkMetrics);
    InjectSparkMetrics.propTypes = injectedProps;
    InjectSparkMetrics.displayName = (0, _recompose.wrapDisplayName)(BaseComponent, 'withSparkMetrics');
    return (0, _reactRedux.connect)(function (state) {
      return {
        metricsStore: state.metricsStore,
        sparkInstance: state.spark.get('spark'),
        sparkState: state.spark.get('status')
      };
    }, function (dispatch) {
      return (0, _redux.bindActionCreators)({
        deleteMetric: _actions.deleteMetric,
        storeMetric: _actions.storeMetric,
        addToQueue: _actions.addToQueue,
        clearQueue: _actions.clearQueue,
        updateMetricsStatus: _actions.updateMetricsStatus
      }, dispatch);
    })(InjectSparkMetrics);
  };
}