import {fromJS} from 'immutable';

import {
  STORE_METRIC,
  ADD_TO_QUEUE,
  DELETE_METRIC,
  CLEAR_QUEUE,
  UPDATE_METRICS_STATUS
} from './actions';

const initialState = fromJS({
  items: {},
  queue: [],
  status: {
    isSendingQueue: false
  }
});

export default function reducer(state = initialState, action) {
  switch (action.type) {
    case STORE_METRIC:
      return state.setIn(['items', action.payload.name], fromJS(action.payload.data));
    case DELETE_METRIC:
      return state.deleteIn(['items', action.payload.name]);
    case ADD_TO_QUEUE: {
      const newQueue = state.get('queue').push(fromJS(action.payload.data));

      return state.set('queue', newQueue);
    }
    case CLEAR_QUEUE:
      return state.set('queue', fromJS([]));
    case UPDATE_METRICS_STATUS:
      return state.mergeDeepIn(['status'], action.payload.status);
    default:
      return state;
  }
}
